#! /usr/bin/python

import defs

class Generator:
    trans_table={"char *":"string",
                 "int *":"int []",
                 "double *":"double []",
                 "float *":"float []"
                 }
    def Generator(self):
        pass

    def ActualizeFormals(self,formals):
        retstr=""
        parts=formals.split(",")

        if len(parts) == 1:
            #happens on 'VOID'
            pass
        else:
            for part in parts:
                part=part.strip()
                #print ">"+part+"<"
                retstr=retstr+" "+part.split(" ")[-1]+","
        
        return retstr[:-1];

    def CollapseTranslate(self,list_of_dict):
        retstr=""
        for dicts in list_of_dict:
            typ = dicts.items()[0][0]
            arg = dicts.items()[0][1]
            
            val = Generator.trans_table.get(typ)
            if val == None:
                val=typ
            retstr=retstr+" "+val+" "+arg+","
        return retstr[:-1]

    def CamelCaps(self,name):
        """convert [g2_open_mouth] -> G2.OpenMouth] """
        parts=name.split("_")[1:]
        retstr=""
        for i in parts:
            retstr = retstr + str(i[0].upper()) + i[1:]
        return retstr
    
    def Generate(self):
        for func in defs.function_list:
            print "[DllImport(\"libg2\")]"
            val=Generator.trans_table.get(func[0],func[0]);
            formals=self.CollapseTranslate(func[2]);
            actuals=self.ActualizeFormals(formals);
            print "static extern ",val,func[1],"(",formals,") ;"
            print "public ",val,self.CamelCaps(func[1]),"(",self.CollapseTranslate(func[2]),") "
            print "{"
            if val!="void":
                print val,"rtype;"
                print "rtype = "
            print "\t",func[1],"(",actuals,") ;"
            if val!="void":
                print "\t return rtype;"
            else:
                print "\t return;"
            print "}"
             

                

if __name__ == "__main__":
    g = Generator()
    g.Generate()
