using System;
using Mono.G2;

class G2Test
{

  static void X11Test()
  {
    G2 d=G2.OpenX11(100,100);
    d.Line(10,10,90,90);
    Console.ReadLine();
    //d.Close();
  }
  
  static void PSTest()
  {
    G2 d=G2.OpenPS("line.ps", G2.PSPaper.A4, G2.PSOrientation.Landscape);
    d.Line(10,10,90,90);
    Console.ReadLine();
    d.Close();
  }

  static void printf(string s)
  {
    Console.Write(s);
  }

  static void TestArc()
  {
    int i, j;
    G2 [] dev = new G2 [10];
    G2 d;
    int ndev=0;
    double y;

    d=G2.OpenVd();      /* open virtual device */
    printf("Adding..");
    

    printf("..EPSF");
    dev[ndev]=G2.OpenEPSF("g2_arc.eps");
    d.Attach(dev[ndev]);
    ndev++;
    
    printf("..EPSF_CLIP");
    dev[ndev]=G2.OpenEPSFCLIP("g2_arc_clip.eps",400,400);
    d.Attach(dev[ndev]);
    ndev++;

    printf("..FIG");
    dev[ndev]=G2.OpenFIG("g2_arc.fig");
    d.Attach(dev[ndev]);
    ndev++;

    printf("..X11");
    dev[ndev]=G2.OpenX11(400,400);
    d.Attach(dev[ndev]);
    ndev++;


    printf("..PS");
    dev[ndev]=G2.OpenPS("arc.ps", G2.PSPaper.A6, G2.PSOrientation.Landscape);
    d.Attach(dev[ndev]);
    ndev++;

    printf("..GD(png)");
    dev[ndev]=new  G2(G2.GDType.png,"g2_arc.png", 400, 400);
    d.Attach(dev[ndev]);
    ndev++;

    printf("..GD(jpeg)");
    dev[ndev]=new G2(G2.GDType.jpeg,"g2_arc.jpg", 400, 400);
    d.Attach(dev[ndev]);
    ndev++;

#if false
 /* Im not a WIN32 platform freak! */
    printf("..WIN32");
    dev[ndev]=g2_open_win32(400, 400,"g2_arc",0);
    d.Attach(dev[ndev]);
    ndev++;

    printf("..WMF32");
    dev[ndev]=g2_open_win32(775, 575,"g2_arc.emf",1);
    g2_attach(d, dev[ndev]);
    ndev++;
#endif

    d.SetAutoFlush=true;

    printf("\n");

    d.String(10, 50,"90,90");
    d.String(10,100,"90,360");
    d.String(10,150,"90,0");
    d.String(10,200,"360,90");
    d.String(10,250,"-45,45");
    d.String(10,300,"-45,-315");
    d.String(10,350,"-495,-405");

    d.Arc( 100,  50, 45, 25, 90, 90);
    d.Arc( 100, 100, 45, 25, 90, 360);
    d.Arc( 100, 150, 45, 25, 90, 0);
    d.Arc( 100, 200, 45, 25, 360, 90);
    d.Arc( 100, 250, 45, 25, -45, 45);
    d.Arc( 100, 300, 45, 25, -45, -315);
    d.Arc( 100, 350, 45, 25, -495, -405);

    d.FilledArc( 100,  50, 40, 20, 90, 90);
    d.FilledArc( 100, 100, 40, 20, 90, 360);
    d.FilledArc( 100, 150, 40, 20, 90, 0);
    d.FilledArc( 100, 200, 40, 20, 360, 90);
    d.FilledArc( 100, 250, 40, 20, -45, 45);
    d.FilledArc( 100, 300, 40, 20, -45, -315);
    d.FilledArc( 100, 350, 40, 20, -495, -405);


    
    d.String(320, 50,"0,0");
    d.String(320,100,"360,90");
    d.String(320,150,"0,90");
    d.String(320,200,"90,360");
    d.String(320,250,"45,-45");
    d.String(320,300,"-315,-45");
    d.String(320,350,"-405,-495");

    d.Arc( 250,  50, 45, 25, 0, 0);
    d.Arc( 250, 100, 45, 25, 360, 90);
    d.Arc( 250, 150, 45, 25, 0, 90);
    d.Arc( 250, 200, 45, 25, 90, 360);
    d.Arc( 250, 250, 45, 25, 45, -45);
    d.Arc( 250, 300, 45, 25, -315, -45);
    d.Arc( 250, 350, 45, 25, -405, -495);

    d.FilledArc( 250,  50, 40, 20, 90, 90);
    d.FilledArc( 250, 100, 40, 20, 360, 90);
    d.FilledArc( 250, 150, 40, 20, 0, 90);
    d.FilledArc( 250, 200, 40, 20, 90, 360);
    d.FilledArc( 250, 250, 40, 20, 45, -45);
    d.FilledArc( 250, 300, 40, 20, -315, -45);
    d.FilledArc( 250, 350, 40, 20, -405, -495);

    d.Flush();
    printf("\nDone.\n[Enter]\n");
    Console.ReadLine();
    d.Close();
    return ;    
  }

  
  static void SplineCurves(G2 id)
  {
    const int n = 14;
    const int o = 60;
    const double tn = 0.6;
    const int X11 = 0;
    
    int i;
    double [] points = new double[2*n];
    double [] dy   =  {  10.0, 280.0, 140.0, 200.0,  60.0, 120.0, 380.0,
			 500.0, 480.0, 400.0, 220.0, 180.0, 260.0, 340.0};
    
    for (i = 0; i < n; i++) {
      points[(i+i)]	= (i*o)+20.00;       /* from 20 to 800 (20+(13*60)) */
      points[(i+i+1)]	= dy[i];
    }
    id.Pen(1);
    id.PolyLine(points);
    id.Pen(3);
    id.Spline( points, o);
    id.Pen( 7);
    id.BSpline(  points, o);
    id.Pen( 10);
    id.Raspln(  points, tn);
    id.Pen( 19);
    id.Para3(  points);
    id.Pen( 22);
    id.Para5( points);
  }
  

  static void SplineAxes(G2 id)
  {
    id.Line( 5, 300, 810, 300);
    id.Line( 400, 5, 400, 560);
  }

   static void SplineDraw(G2 id)
  {
    id.Rectangle( 5, 5, 810, 560);	/* window: 815 x 565 */
    SplineAxes(id);
    SplineCurves(id);
  }

  
   static void SplineTest()
  {
    G2 [] dev = new G2 [5];
    G2 id;

    id=G2.OpenVd(); /* open virtual device */
    printf("\nAdding..");
    
    printf("..PS");
    dev[0]=G2.OpenPS("g2_splines_demo.ps", G2.PSPaper.A4, G2.PSOrientation.Landscape);
    id.Attach(dev[0]);

    printf("..X11");
    dev[1]=G2.OpenX11(400, 400);
    id.Attach(dev[1]);


    printf("..GD");
    dev[2]=G2.OpenGd("g2_splines_demo.png", 850, 600, G2.GDType.png);
    id.Attach(dev[2]);


#if false
 /* like I said, WIN32 isnt for me  */
    printf("..WIN32");
    dev[3]=g2_open_win32(850, 600,"g2_splines_demo",0);
	g2_set_auto_flush(dev[3],0);
    g2_attach( dev[3]);
#endif

#if false 
/* like I said, WIN32 isnt for me  */
    printf("..WMF32");
    dev[4]=g2_open_win32(850, 600,"g2_splines_demo.emf",1);
	g2_set_auto_flush(dev[3],0);
    g2_attach( dev[4]);
#endif
    
    id.SetAutoFlush=false;
    id.SetCoordinateSystem( 12, 15, 1.0, 1.0);
    
    SplineDraw(id);
    id.Flush();

    printf("\nDone.\n[Enter]\n");
    Console.ReadLine();
    id.Close();
    return ;
  }
  
public static void Main(string [] args)
  {
    X11Test();
    PSTest();
    TestArc();
    SplineTest();
    return ;
  }
}
/* 
   Test the polylines, polygons triangles etc...
*/
